# $Id: Install.py,v 1.3 2002/01/21 20:04:51 thomas Exp $
# $Source: /usr/local/cvs_root/CMFArticle/Extensions/Install.py,v $
__version__ = "$Revision: 1.3 $"[11:-2]

from Products.CMFCore.TypesTool import ContentFactoryMetadata
from Products.CMFCore.DirectoryView import DirectoryView, addDirectoryViews, createDirectoryView
from Products.CMFCore.utils import getToolByName, minimalpath
from Products.CMFArticle import Article, article_globals
from App.Common import package_home
from os import path, listdir, stat
from cStringIO import StringIO
import string

def Install(self):
    """Register CMFArticle with the necessary tools"""
    out = StringIO()
    typestool = getToolByName(self, 'portal_types')
    skinstool = getToolByName(self, 'portal_skins')

    for t in Article.factory_type_information:
        if t['id'] not in typestool.objectIds():
            cfm = apply(ContentFactoryMetadata, (), t)
            typestool._setObject(t['id'], cfm)
            out.write('Registered with the types tool\n')
        else:
            out.write('Object "%s" already existed in the types tool\n' % (
                t['id']))

    # Setup the skins
    if 'article' not in skinstool.objectIds():
        # We need to add Filesystem Directory Views for any directories
        # in our skins/ directory.  These directories should already be
        # configured.
        fp = minimalpath("%s/skins/ptarticle" % package_home(article_globals))
        createDirectoryView(skinstool, fp, 'article')
        out.write("Added %s directory view to portal_skins\n" % fp)

        fp = minimalpath("%s/skins/ptarticle" % package_home(article_globals))
        try:
            createDirectoryView(skinstool, fp, 'article')
            out.write("Added %s directory view to portal_skins\n" % fp)
        except:
            out.write("Couldn't add directory %s to portal_skins\n" % fp)


    # Now we need to go through the skin configurations and insert
    # 'article' into the configurations.  Preferably, this
    # should be right before where 'content' is placed.  Otherwise, we
    # append it to the end.
    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if 'article' not in path:
            try: path.insert(path.index('content'), 'article')
            except ValueError:
                path.append('article')

            path = string.join(path, ', ')
            # addSkinSelection will replace existing skins as well.
            skinstool.addSkinSelection(skin, path)
            out.write("Added 'article' to %s skin\n" % skin)
        else:
            out.write("Skipping %s skin, 'article' is already set up\n" % (
                skin))

    return out.getvalue()

def test(self):
    """Test CMFArticle installation"""
    out = StringIO()
    skinstool = getToolByName(self, 'portal_skins')

    # Setup the skins
    if 'article' not in skinstool.objectIds():
        out.write("'article' not in portal_skins\n")
    else:
        out.write("'article' is in portal_skins\n")

    # Setup the skins
    if 'ptarticle' not in skinstool.objectIds():
        out.write("'ptarticle' not in portal_skins\n")
    else:
        out.write("'ptarticle' is in portal_skins\n")

    for dir in skinstool.objectIds():
        path = getattr(skinstool, dir)
        out.write("Dir %s / %s\n" % (dir, str(path)) )

    # Now we need to go through the skin configurations and insert
    # 'article' into the configurations.  Preferably, this
    # should be right before where 'content' is placed.  Otherwise, we
    # append it to the end.
    skins = skinstool.getSkinSelections()

    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = string.split(path,',')
        out.write("Skin %s: %s \n" % (skin, path) )

    return out.getvalue()
