"""
    Declare link element class.
"""
import zLOG
from AbstractElement import AbstractElement
from AccessControl import ClassSecurityInfo
from Article import Article
import Globals, interfaces

from Products.CMFCore import CMFCorePermissions
import ArticlePermissions

class GoToElement(AbstractElement):
    """
    An intra-page link (go to top).
    """
    __implements__ = (interfaces.Element,)

    meta_type = 'GoTo Element'
    security = ClassSecurityInfo()

    _editableAttributes = ('title',)
    _editableExtraAttributes = ('clear',)
    clear = 'both'
    title = 'Go to top'

    def __init__(self, id):
        self.id = id

    security.declareProtected(ArticlePermissions.ChangeArticles, 'getEditForm')
    def getEditForm(self):
        " Return the skinned name of the edit form "
        return 'agoto_edit'

    security.declareProtected(CMFCorePermissions.View, 'getView')
    def getView(self):
        " Return the skinned name of the edit form "
        return 'agoto_view'

    security.declareProtected(ArticlePermissions.ChangeArticles, 'edit')
    def edit(self, title):
        """ Update the value """
        self.title = str(title)

#    security.declareProtected(CMFCorePermissions.View, 'getElementItems')
#    def getElementItems( self ):
#        """ Return a sequence of element items, used build the article """
#        return self.title is not '' and ((self.title,self.url),) or ()

    def SearchableText(self):
        """
            SeachableText is used for full text seraches of a portal.
            It should return a concatanation of all useful text.
        """
        return self.Description()

    def manage_afterAdd(self, item, container):
        """AbstractElement has an afterAdd method"""
        zLOG.LOG(self.meta_type, zLOG.INFO, 'manage_afterAdd(%s, %s)' % (item.getId(), container.getId()))
        AbstractElement.manage_afterAdd(self, item, container)


Globals.InitializeClass(GoToElement)

# Register as an element type with the Article class
Article._elementTypes.append(GoToElement)
