## Script (Python) "article_editElement"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=REQUEST, RESPONSE, element
##title=
##
"""\
Save changes to the list of element.  This is done by going over
the submitted element records and comparing them against the
elements object's editable attributes.  A 'command' object is
built to send to the Element objects 'apply' method, which in turn
applies the command to the Element objects 'edit' method.
"""
for rec in element:
    elem = context.getElement(rec.id)
    if elem is not None:
        command = {}
        for attr in elem.editableAttributes():
            tmp = getattr(rec, attr, None)
            # Due to having multiple radio buttons on the same page
            # with the same name but belonging to different records,
            # they needed to be associated with different records with ids
            if tmp is None:
                tmp = getattr(rec, '%s__%s' % (attr, rec.id), None)
            command[attr] = tmp
        elem.apply(command)

message='Changes+saved.'
RESPONSE.redirect('%s/article_element_form?portal_status_message=%s' % (
    context.absolute_url(), message)
                  )

