import os, sys, string

if __name__ == '__main__':
    fix_path()
    import Zope
import unittest
import Products.CMFArticle.Article
import Products.CMFArticle.TextElement
import Products.CMFArticle.ImageElement
import Products.CMFArticle.LinkElement
import Products.CMFArticle.TableElement

TEXT = Products.CMFArticle.TextElement.TextElement
IMAG = Products.CMFArticle.ImageElement.ImageElement
LINK = Products.CMFArticle.LinkElement.LinkElement
TABL = Products.CMFArticle.TableElement.TableElement
Article = Products.CMFArticle.Article.Article


class TestArticle(unittest.TestCase):
    """ Test all the general Article cases  """

    def setUp( self ):
        get_transaction().begin()

    def tearDown( self ):
        get_transaction().abort()

    def test_Empty( self ):
        article = Article('top')
        assert len(article._elementTypes) == 5
        query = article.listElements()
        assert len( query ) == 0

    def test_Simple( self ):
        article = Article('top')
        article._setObject('elem__foo', TEXT('elem__foo'))
        #article.elem__foo.edit('bar')
        query = article.listElements()
        assert len(query) == 1
        assert query['foo'] == 'bar'

        article._setObject('elem__baz', LINK('elem__baz'))
        #article.crit__baz.edit(title='Title',url='/')
        elements = article.listElements()
        assert len(elements) == 2
        assert elements['foo'] == 'bar'
        #assert query['baz'] == 43

    # need to fix the rest
    def test_Nested( self ):
        article = Article('top')
        article._setObject('elem__foo', TABL('elem__foo'))
        subarticles = article.listSubarticles()
        assert len(subarticles) == 1
        #article.elem__foo.edit('bar')
        subarticle = Article('qux')
        subarticle._setObject('elem__baz', TABL('elem__baz'))
        #subarticle.crit__baz.edit('bam')
        article._setObject('qux', subarticle, set_owner=0)
        subarticle = article.qux
        elements = subarticle.listElements()
        assert len(elements) == 1, str(elements)
        assert elements['foo'] == 'bar'
        assert elements['baz'] == 'bam'

        #subarticle.acquireCriteria = 0
        #query = subarticle.buildQuery()
        #assert len(query) == 1
        #assert query['baz'] == 'bam'


def test_suite():
    return unittest.makeSuite(TestArticle)

if __name__ == '__main__':
    unittest.TextTestRunner().run(test_suite())
